/* -*- c++ -*- */
/* 
 * Copyright 2019 Thomas Kolb.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_HAMNET70_ASYNC_SCRAMBLER_IMPL_H
#define INCLUDED_HAMNET70_ASYNC_SCRAMBLER_IMPL_H

#include <hamnet70/async_scrambler.h>

namespace gr {
	namespace hamnet70 {

		class async_scrambler_impl : public async_scrambler
		{
			private:
				pmt::pmt_t d_in_port;
				pmt::pmt_t d_out_port;

				uint8_t d_start;
				uint8_t d_polynom;

			public:
				async_scrambler_impl(uint8_t start, uint8_t polynom);
				~async_scrambler_impl();

				// Where all the action really happens
				/*
				void forecast (int noutput_items, gr_vector_int &ninput_items_required);

				int general_work(int noutput_items,
						gr_vector_int &ninput_items,
						gr_vector_const_void_star &input_items,
						gr_vector_void_star &output_items);*/

				void scramble(pmt::pmt_t pdu);
		};

	} // namespace hamnet70
} // namespace gr

#endif /* INCLUDED_HAMNET70_ASYNC_SCRAMBLER_IMPL_H */

