/* -*- c++ -*- */
/*
 * Copyright 2019 Thomas Kolb.
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_HAMNET70_QAM_PHASE_TRACKER_IMPL_H
#define INCLUDED_HAMNET70_QAM_PHASE_TRACKER_IMPL_H

#include <hamnet70/qam_phase_tracker.h>

namespace gr {
	namespace hamnet70 {

		class qam_phase_tracker_impl : public qam_phase_tracker
		{
			private:
				pmt::pmt_t              d_startTag;
				float                   d_alpha;
				float                   d_avgPhaseOffset;
				std::vector<gr_complex> d_refSymbols;
				std::vector<float>      d_refPhase;

			public:
				qam_phase_tracker_impl(const std::vector<gr_complex> &symbols, float alpha, const std::string &start_tag);
				~qam_phase_tracker_impl();

				// Where all the action really happens
				int work(
						int noutput_items,
						gr_vector_const_void_star &input_items,
						gr_vector_void_star &output_items
						);
		};

	} // namespace hamnet70
} // namespace gr

#endif /* INCLUDED_HAMNET70_QAM_PHASE_TRACKER_IMPL_H */

